﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_packed_circles
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private float InnerRadius, OuterRadius;

        // Display the PrintPreviewDialog.
        private void btnPreview_Click(object sender, EventArgs e)
        {
            InnerRadius = 100 * float.Parse(txtInnerRadius.Text);
            OuterRadius = 100 * float.Parse(txtOuterRadius.Text);
            Form frm = ppdCircles as Form;
            frm.WindowState = FormWindowState.Maximized;
            ppdCircles.PrintPreviewControl.Zoom = 1.0;
            ppdCircles.PrintPreviewControl.UseAntiAlias = true;
            ppdCircles.ShowDialog();
        }

        // Generate the printout.
        private void pdocCircles_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            float cx = e.MarginBounds.Left + OuterRadius;
            float cy = e.MarginBounds.Top + OuterRadius;

            float dx = OuterRadius;
            float dy = (float)(OuterRadius * Math.Sqrt(3));

            using (Pen dashed_pen = new Pen(Color.Black))
            {
                dashed_pen.DashPattern = new float[] { 10, 10 };

                while (cy - OuterRadius < e.MarginBounds.Bottom)
                {
                    // Make rectangles for the first circle.
                    RectangleF outer_rect = new RectangleF(
                        cx - OuterRadius,
                        cy - OuterRadius,
                        2 * OuterRadius,
                        2 * OuterRadius);
                    RectangleF inner_rect = new RectangleF(
                        cx - InnerRadius,
                        cy - InnerRadius,
                        2 * InnerRadius,
                        2 * InnerRadius);

                    // Draw a row.
                    while (outer_rect.Left < e.MarginBounds.Right)
                    {
                        e.Graphics.DrawEllipse(dashed_pen, outer_rect);
                        e.Graphics.DrawEllipse(Pens.Black, inner_rect);
                        outer_rect.X += 2 * OuterRadius;
                        inner_rect.X += 2 * OuterRadius;
                    }

                    // Prepare for the next row.
                    cx -= dx;
                    if (cx < e.MarginBounds.Left) cx += 2 * OuterRadius;
                    cy += dy;
                }
            }
        }
    }
}
